# NeatUI - 努力向世界上最好的 React UI 库前进

_组件文档地址：_[NeatUI](http://f2e.developer.163.com/neatui/v1/index.html)
POPO 反馈群: 1433528

## 组件列表

- [x] Button 按钮
- [x] 栅格系统(Row、Col)
- [x] Icon 图标
- [x] Modal 弹出框
- [x] Confirm 弹出框静态方法
- [x] Tooltip 提示框
- [x] Pagination 分页
- [x] Carousel 走马灯
- [x] DatePicker 时间选择器
- [x] Progress 进度条
- [x] LoadingBar 顶部进度条
- [x] Tabs 标签页
- [x] Table 表格
- [x] Tag 标签
- [x] Menu 下拉菜单
- [x] Snackbar 通知框
- [x] Breadcrumb 面包屑
- [x] Form 表单
- [x] Input 输入框
- [x] Radio 单选框
- [x] select 选择框
- [x] Checkbox 多选框
- [x] Cascader 级联选择
- [x] Affix 固钉
- [x] Uploader 上传
- [x] Autocomplete 自动补全
- [ ] Steps 步骤条
- [ ] Editor 编辑器 \*

## 安装

### 使用 npm 安装:

```
$ npm i --save react react-dom neatui
```

### 项目中引用：

```js
// 引入组件库样式
import 'neatui/es/scss/index.css';
// 引入需要的组件
import { Button, Modal } from 'neatui';
```

如果需要使用自定义主题

```js
// 引入组件库样式
import './style.scss';
// 引入需要的组件
import { Button, Modal } from 'neatui';
```

```css
/* style.scss */
@primary-color: 主题色;
@import 'neatui/es/scss/index.scss';
```

## 开发：

### 安装依赖

```
$ yarn install
```

### 启动 storybook

```
$ yarn storybook
```

### 打包：

```
$ yarn build
```

### 文档项目：

#### 本地文档预览

```
$ yarn doc
```

#### 根据文内注释从新生成文档

    node ./script/getDocApi.js

目标: src/component/doc/zh-cn.md
下的 react-component-api 段落

react-component-api 上边部分需自己写

忽略如下代码

    /**
     * @ignore
     * */

#### 文档打包

```
$ yarn build:doc
```

#### 部署

```
$ scp -r  doc/build/* 你的邮箱名@f2e-vps:/home/appops/html/neatui/v1
```
